<template>
  <q-drawer
    :model-value="drawer"
    side="right"
    bordered
    class="q-mt-lg"
  >
    <q-scroll-area style="height: 100%;">
      <q-list>
        <q-item
          v-for="train in trains"
          :key="train.id"
          v-ripple
          clickable
          @click="trainDetailClick(train)"
        >
          <q-separator />
          <q-item-section>
            <q-img
              v-if="train.img"
              :src="require('@/assets/trains/' + train.img).default"
            >
              <div class="absolute-full text-subtitle2 text-center">
                <span class="text-h6">{{ train.name }}</span>
                <q-icon
                  v-if="train.light"
                  color="accent"
                  name="lightbulb"
                  size="sm"
                />
                <div>{{ speedText(train.speed) }}</div>
              </div>
            </q-img>

            <div
              v-else
              class="text-center"
            >
              <span class="text-h6">{{ train.name }}</span>
              <q-icon
                v-if="train.light"
                color="accent"
                name="lightbulb"
                size="sm"
              />
              <div>{{ speedText(train.speed) }}</div>
            </div>
          </q-item-section>
        </q-item>
      </q-list>
    </q-scroll-area>
  </q-drawer>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/runtime-core'
import { useQuasar } from 'quasar'
import { TrainModel } from 'web_trains_types'

import TrainDialog from '@/components/TrainDialog.vue'
import useTrainStore from '@/store/trainStore'

export default defineComponent({
  name: 'TrainDrawer',
  props: {
    drawer: {
      type: Boolean,
      required: true
    },
    detail: {
      type: Boolean,
      required: true
    }
  },
  setup (props): any {
    const $q = useQuasar()

    const trains = ref<TrainModel[]>()

    $q.loading.show()

    const trainStore = useTrainStore()

    trainStore.trains
      .then((data) => {
        trains.value = data
      })
      .finally(() => $q.loading.hide())

    const trainDetailClick = (train: TrainModel) => {
      $q.dialog({
        component: TrainDialog,
        componentProps: {
          train: train,
          detail: props.detail
        }
      })
    }

    const speedText = (speed: number): string => {
      if (speed > 0) {
        return 'Jede: ' + speed
      }

      if (speed < 0) {
        return 'Couvá: ' + (-speed)
      }

      return 'stojí'
    }

    return {
      trains,
      trainDetailClick,
      speedText
    }
  }
})

</script>
